package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.*
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.Color
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songFinale() {
    step(StepCue.MusicStart("Finale", 10.seconds)) {
        actors {
            -"Mina"
            -"Jonathan"
            +"Van Helsing / von links"
        }

        rightSpotTarget = "Van Helsing"

        onRun {
            backlightBar.color.static(Color.DARK_BLUE)
            backlightBar.brightness.fade(50.percent, 10.seconds)
            Spots.right.brightness.fade(100.percent, 5.seconds)

            BlinderBars.all {
                it.preset.static(StairvilleSplb.Preset.STUB)  // pulsing, dark
                it.presetSpeed.fade(start = 0.percent, end = 50.percent, duration = 20.seconds)
                it.brightness.fade(25.percent, 3.seconds)
            }
        }
    }

    step(StepCue.Text("Van Helsing", "Sie sind überall!")) {
        actors {
            +"Alle"
        }
    }

    step(StepCue.Text("Van Helsing", "Nur eines haben sie nicht…")) {
        rightSpotTarget = null

        onRun {
            Spots.right.brightness.off(10.seconds)
            FrontLights.all { it.brightness.fade(100.percent, 5.seconds)  }
            backlightBar.color.cycle(12.seconds)
            backlightBar.brightness.fade(100.percent, 20.seconds)

            BlinderBars.all {
                it.preset.static(StairvilleSplb.Preset.STUB)  // warm-white, flowing
            }
        }
    }

    lightStep(StepCue.Custom("Musik: Schlussschlag")) {
        FrontLights.all { it.brightness.off(1.seconds) }
        BlinderBars.all { it.brightness.off(1.seconds) }
        backlightBar.brightness.off(1.seconds)
    }

    step(StepCue.MusicEnd) {
        actors {
            -"Van Helsing"
            -"Alle"
        }
    }
}