package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.CoemarProWash
import de.moritzruth.dracula_musical.device.Spots
import de.moritzruth.dracula_musical.device.Washs
import de.moritzruth.dracula_musical.device.backlightBar
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.Color
import de.moritzruth.theaterdsl.value.degrees
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.minutes
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songQuartett() {
    step(StepCue.MusicStart("Quartett", 3.minutes)) {
        onRun {
            Washs.both {
                it.pointAtStageCenter()
                it.colorWheelMode.static(CoemarProWash.ColorWheelMode.Violet)
            }
        }

        leftSpotTarget = "Vampire (Ziel wechseln, wenn aus)"
        rightSpotTarget = "Vampire (Ziel wechseln, wenn aus)"
    }

    lightStep(StepCue.Custom("Musik: Einsetzen des Klaviers")) {
        backlightBar.color.fadeRandomAround(270.degrees, 50.degrees, 10.seconds)
        backlightBar.brightness.fade(50.percent, 6.seconds)

        Washs.both { it.brightness.fade(100.percent, 5.seconds) }

        Spots.left.brightness.sine(16.seconds)
        Spots.right.brightness.sine(12.seconds)
    }

    lightStep(StepCue.Text("Eloïse", "Findest du nur bei mir.")) {
        Washs.both { it.brightness.off(3.seconds) }
    }

    lightStep(StepCue.Custom("Musik: Hoher Ton von Violine")) {
        Spots.left.brightness.off(3.seconds)
        Spots.right.brightness.off(3.seconds)

        backlightBar.color.static(Color.RED)
        backlightBar.brightness.pulse(1.8.seconds, 0.15.seconds, 0.2.seconds, peak = 40.percent, startDelay = 0.seconds)

        Washs.both {
            it.colorWheelMode.static(CoemarProWash.ColorWheelMode.Red)
            it.brightness.pulse(1.8.seconds, 0.15.seconds, 0.3.seconds, startDelay = 0.4.seconds)
        }
    }

    step(StepCue.MusicEnd) {
        leftSpotTarget = null
        rightSpotTarget = null
    }
}