import { defineConfig, transformerDirectives } from "unocss"
import { presetWind, colors } from "@unocss/preset-wind3"

const generateValues = (max: number, fn: (step: number) => any) => {
    const object: Record<number, any> = {}

    for (let i = 1; i <= max; i++) {
        object[i] = fn(i)
    }

    return object
}

export default defineConfig({
    presets: [
        presetWind({
            arbitraryVariants: true,
            preflight: true
        })
    ],
    theme: {
        fontFamily: {
            sans: `"Manrope Variable", sans-serif`,
            system: "sans-serif"
        },
        colors: {
            black: colors.black,
            white: colors.white,
            gray: colors.stone,
            red: colors.red,
            yellow: colors.amber,
            orange: colors.orange,
            green: colors.green,
            blue: colors.blue,
            violet: colors.fuchsia,
            light: colors.light,
            dark: colors.dark,
            transparent: colors.transparent
        }
    },
    transformers: [
        transformerDirectives()
    ]
})
